#%%
import numpy as np
from scico import plot, functional
import matplotlib.pyplot as plt
from utils.scico_utils import *
import pyproximal

#%%
N = 256
g0 = np.linspace(0, 2 * np.pi, N).reshape((N, 1))
g1 = np.linspace(0, 2 * np.pi, N).reshape((1, N))
x = np.cos(3 * g0) * np.sin(2 * g1)

x_sq = x.copy()
x_sq[x_sq>=0] = np.max(x)
x_sq[x_sq<0] = np.min(x)
x [:, int(2*N/3):] = x_sq[:, int(2*N/3):]

x += np.random.normal(0, .1, (x.shape[0],x.shape[1])) 

f = TV2DNorm(1e0)
y = f.prox(x, 5e-2)

f = TV2DNorm_Clip(1e0)
z = f.prox(x, 5e-2)

plt.figure(figsize=(12,5))
plt.subplot(131); plt.imshow(x); plt.clim([-2,2]); plt.colorbar(fraction=0.045, pad=0.04); plt.title('Raw'); plt.axis('off')
plt.subplot(132); plt.imshow(y); plt.clim([-2,2]); plt.colorbar(fraction=0.045, pad=0.04); plt.title('Shrink-Highpass'); plt.axis('off')
plt.subplot(133); plt.imshow(z); plt.clim([-2,2]); plt.colorbar(fraction=0.045, pad=0.04); plt.title('Shrink-Forward'); plt.axis('off')
plt.show()

plt.figure(figsize=(10,4))
m = 128
plt.subplot(121); plt.plot(x[m], label='Raw')
plt.subplot(121); plt.plot(y[m], label='Shrink-Highpass')
plt.subplot(121); plt.plot(z[m], label='Shrink-Forward')
plt.legend(); plt.title(f'eta={1e0*5e-2}')

f = TV2DNorm(2e0)
y = f.prox(x, 5e-2)

f = TV2DNorm_Clip(2e0)
z = f.prox(x, 5e-2)

m = 128
plt.subplot(122); plt.plot(x[m], label='Raw')
plt.subplot(122); plt.plot(y[m], label='Shrink-Highpass')
plt.subplot(122); plt.plot(z[m], label='Shrink-Forward')
plt.legend(); plt.title(f'eta={2e0*5e-2}')

